package example_file_class;

import java.util.Scanner;
import java.io.File;
import java.io.IOException;

public class FilesClassExamples {
	public static void main(String[] args) throws IOException {
		File inFile = new File( "src/example_file_class/numbers.txt" );
		

		System.out.println("    Does it exist? " + inFile.exists());
		System.out.println("   Can it be read? " + inFile.canRead());
		System.out.println("Can it be written? " + inFile.canWrite());
		System.out.println("Is it a directory? " + inFile.isDirectory());
		System.out.println("     Is it a file? " + inFile.isFile());
		System.out.println("     Is it hidden? " + inFile.isHidden());
		System.out.println("  Number of bytes: " + inFile.length() + " bytes");
//		System.out.println("    Absolute file: " + inFile.getAbsoluteFile());
		System.out.println("    Absolute path: " + inFile.getAbsolutePath());
//		System.out.println("   Canonical path: " + inFile.getCanonicalPath());
		System.out.println("             Path: " + inFile.getPath());
		System.out.println("           Parent: " + inFile.getParent());
		System.out.println("    Last modified: " + new java.util.Date(inFile.lastModified()));
		// Derive the absolute path without the file name.
		String absPath = inFile.getAbsolutePath();
		int posEndPath = absPath.lastIndexOf(File.separator);
		String filePath = absPath.substring(0,posEndPath+1);
		System.out.println("Abs path (derived): " + filePath);
		
		String userDir = System.getProperty("user.dir");
		System.out.println("          user.dir: " + userDir);
		String userHome = System.getProperty("user.home");
		System.out.println("         user.home: " + userDir);

		if( inFile.exists()) {
			try {
				Scanner input = new Scanner( inFile );
				while( input.hasNext() ) {
					System.out.println(input.nextInt());
				}
				input.close();
			}
			catch( IOException e ) {
				System.out.println(e);
			}
		}
		else{
			System.out.println("File doesn't exist");
		}
	}
}

