package example_read_employees;

import java.util.ArrayList;
import java.util.Scanner;
import java.io.File;
import java.io.FileNotFoundException;

/**
 * Reads data for Employees storing emp objects in a list. Illustrates 3 different file 
 * arrangements, but code works on any of these. This example is in the book.
 * @author dgibson
 *
 */
public class ReadEmployees2 {
	public static void main(String[] args) {
		String path = "src/example_read_employees/";
		
		String[] fileNames = {"employees1.txt", "employees2.txt", "employees3.txt"};
		
		for(String fileName : fileNames) {
			ArrayList<Employee> employees = new ArrayList<>();

			String fullFileName = path + fileName; 
			File inFile = new File(fullFileName);
			System.out.println("Reading file: " + fileName);
			
			try {
				// Read file
				Scanner input = new Scanner( inFile );
				while( input.hasNext() ) {
					String name = input.next();
					double salary = input.nextDouble();
					int age = input.nextInt();
					employees.add(new Employee( name, salary, age ));
				}
				input.close();
			}
			catch(FileNotFoundException e) {
				System.out.println(e);
			}
		
			for( Employee e : employees ) {
				System.out.println(e);
			}
			employees.clear();
			System.out.println();
		}
		
	}
}

