package example_read_people_and_dogs;

import java.util.ArrayList;
import java.util.Scanner;
import java.io.File;
import java.io.IOException;
/**
 * Reads data for people who have any number of dogs and builds a list of people.
 * The approach is to read token-by-token, as opposed to ReadPeopleAndDogs_Ver2.java,
 * which reads the data by the line.
 * @author dgibson
 *
 */
public class ReadPeopleAndDogs_Ver1 {
	public static void main(String[] args) {
		ArrayList<Person> people = new ArrayList<>();
		File inFile = new File( "src/example_read_people_and_dogs/peopleAndDogs.txt" );
		
		try {
			Scanner input = new Scanner( inFile );
			while( input.hasNext() ) {
				String name = input.next();
				Person p = new Person(name);
				int numDogs = input.nextInt();
				for(int i=0; i<numDogs; i++){
					String dogName = input.next();
					Dog dog = new Dog(dogName);
					p.addDog(dog);
				}
				people.add(p);
			}
			input.close();
		}
		catch( IOException e ) {
			System.out.println(e);
		}

		for(Person p : people) { // Comm
			System.out.println(p);
		}
	}
}

