package example_read_people_and_dogs;

import java.util.ArrayList;
import java.util.Scanner;
import java.io.File;
import java.io.IOException;
/**
 * Same as ReadPeopleAndDogs_Ver1.java, i.e. reads data for people who have any number of dogs 
 * and builds a list of people. The approach here, is to read by line as opposed to by token.
 * @author dgibson
 *
 */
public class ReadPeopleAndDogs_Ver2 {
	public static void main(String[] args) {
		ArrayList<Person> people = new ArrayList<>();
		File inFile = new File( "src/example_read_people_and_dogs/peopleAndDogs.txt" );
		
		try {
			Scanner input = new Scanner( inFile );
			while( input.hasNext() ) {
				String line = input.nextLine();
				String[] tokens = line.split(" ");
				String name = tokens[0];
				int numDogs = Integer.parseInt(tokens[1]);
				Person p = new Person(name);
				for(int i=0; i<numDogs; i++){
					String dogName = input.nextLine();
					Dog dog = new Dog(dogName);
					p.addDog(dog);
				}
				people.add(p);
			}
			input.close();
		}
		catch( IOException e ) {
			System.out.println(e);
		}

		for(Person p : people) {
			System.out.println(p);
		}
	}
}

