package example_read_previous_words;

import java.util.ArrayList;
import java.util.Scanner;
import java.io.File;
import java.io.IOException;
/**
 * Write code to read a file composed of words and integers in any random order, creating
 * a list of the words and a list of the integers. For example, this input:
 * "33 992 guitar 8 fire 29 344 5 hat pick rain 1 horse 18" should produce this output:
 * 
 *  ints: [33, 992, 8, 29, 344, 5, 1, 18]
 * words: [guitar, fire, hat, pick, rain, horse]

 * @author dgibson
 *
 */
public class ReadPreviousWords {
	public static void main(String[] args) {
		File file = new File( "src/example_read_previous_words/numbersAndWords.txt" );
		ArrayList<String> words = readWords(file);
		System.out.println(" words: " + words);
	}
	
	public static ArrayList<String> readWords(File file) {
		ArrayList<String> allTokens = new ArrayList<>();
		ArrayList<String> words = new ArrayList<>();
	
		// Read all tokens
		try {
			Scanner input = new Scanner(file);
			while( input.hasNext() ) {
				String token = input.next();
				allTokens.add(token);
			}
			input.close();
		}
		catch( IOException e ) {
			System.out.println(e);
		}
	
		// Extract words
		for(int i=0; i<allTokens.size(); i++) {
			String token = allTokens.get(i);
			if(isInteger(token)) {
				int num = Integer.parseInt(token);
				int start = i-num;
				for(int j=start; j<i; j++) {
					words.add(allTokens.get(j));
				}
			}
		}
		return words;
	}
	
	private static boolean isInteger(String str) {
		try {
			int x = Integer.parseInt(str);
			return true;
		}
		catch(NumberFormatException nfe) {
			return false;
		}
	}
}

