package exercise_bank_accounts_ver1;

import java.util.ArrayList;
import java.util.List;

public class Bank {
	private List<Account> accounts = new ArrayList<>();

	public Bank() {
	}
	
	public int getNumAccounts() {
		return accounts.size();
	}
	
	public void addAccount(Account a) {
		accounts.add(a);
	}
	
	public Account getAccount(int i) {
		if((i >= 0) && (i < accounts.size())) {
			return accounts.get(i);
		}
		return null;
	}
	
	public double getTotalBalance() {
		double sum=0.0;
		for(Account a : accounts) {
			sum += a.getBalance();
		}
		return sum;
	}
	
	@Override
	public String toString() {
		String msg = String.format("Tot Bal=$%,.2f, Num Acnts=%d\n", 
				getTotalBalance(), getNumAccounts());
		for(int i=0; i<getNumAccounts(); i++) {
			String acnt = String.format("%d - %s\n", i+1, accounts.get(i));
			msg += acnt;
		}
		return msg;
	}
}
