package exercise_bank_accounts_ver1;

import java.io.File;
import java.io.IOException;
import java.util.Scanner;

public class PersonIO {

	public static void main(String[] args) {
		// See PersionIOTest.java for more tests
		File inFile = new File( "src/exercise_bank_accounts_ver1/accounts.txt" );
		Bank bank = readAccounts(inFile);
		
		for(int i=0; i<bank.getNumAccounts(); i++) {
			System.out.println(bank.getAccount(i));
		}

	}
	
	public static Bank readAccounts(File file) {
		Bank bank = new Bank();
	
		try {
			Scanner input = new Scanner(file);
			String name = input.nextLine();  // assume first line is a Person
			Account a;
			while(input.hasNext()) {
				String line = input.nextLine();
				String[] tokens = line.split("\\s");
				String type = tokens[0];
				double balance = Double.parseDouble(tokens[1]);
				if(type.equals("b")) {
					a = new BasicAccount(balance);
				}
				else if(tokens.length == 2) {
					a = new GoldAccount(balance);
				}
				else {
					double intRate = Double.parseDouble(tokens[2]);
					a = new GoldAccount(balance, intRate);
				}
				bank.addAccount(a);
			}
			input.close();
		}
		catch( IOException e ) {
			System.out.println(e);
		}
		return bank;
	}
}
