package exercise_person_accounts_ver1;

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

/*
 * the solution...
 */
public class PersonIO {

	public static void main(String[] args) {
		
	}
	// Solution utilizing nextLine/split approach
	public static List<Person> readPeople(File file) {
		ArrayList<Person> people = new ArrayList<>();
		try {
			Scanner input = new Scanner(file);

			Account a;
			while(input.hasNext()) {
				String line = input.nextLine();
				String[] tokens = line.split("\\s");
				String name = tokens[0];
				int numAccounts = Integer.parseInt(tokens[1]);
				Person p = new Person(name);
				for(int i=0; i<numAccounts; i++) {
					line = input.nextLine();
					tokens = line.split("\\s");
					double bal = Double.parseDouble(tokens[1]);
					if(tokens.length == 2) {  // BasicAccount
						a = new BasicAccount(bal);
					}
					else {  // GoldAccount
						double intRate = Double.parseDouble(tokens[2]);
						a = new GoldAccount(bal, intRate);
					}
					p.addAccount(a);
				}
				people.add(p);
			}
			input.close();
		}
		catch( IOException e ) {
			System.out.println(e);
		}
		return people;
	}

	// Solution utilizing next/nextInt/nextDouble approach
	public static List<Person> readPeople2(File file) {
		ArrayList<Person> people = new ArrayList<>();
		try {
			Scanner input = new Scanner(file);
			while(input.hasNext()) {
				String name = input.next();
				int numAccounts = input.nextInt();
				Person p = new Person(name);
				for(int i=0; i<numAccounts; i++) {
					Account a;
					String type = input.next();
					double bal = input.nextDouble();
					if(type.equals("b")) {
						a = new BasicAccount(bal);
					}
					else {
						double intRate = input.nextDouble();
						a = new GoldAccount(bal, intRate);
					}
					p.addAccount(a);
				}
				people.add(p);
			}
			input.close();
		}
		catch( IOException e ) {
			System.out.println(e);
		}
		return people;
	}

	public static void writePeople(File file, List<Person> people) {
		String output;
		try {
			PrintWriter writer = new PrintWriter(file);
			for(Person p : people) {
				writer.println(p.getName() + " " + p.getNumAccounts());
				for(int i=0; i<p.getNumAccounts(); i++) {
					Account a = p.getAccount(i);
					double bal = a.getBalance();
					if(a instanceof BasicAccount) {
						output = "b " + bal;
					}
					else {
						double intRate = ((GoldAccount)a).getInterestRate();
						output = "g " + bal + " " + intRate;
						
					}
					writer.println(output);
				}
			}
			writer.close();
		}
		catch (IOException ioe) {
			System.out.println("Problem creating file or writing");
		}

	}

}
