package exercise_person_accounts_ver1;

import java.io.File;
import java.io.IOException;
import java.nio.file.Files;
import java.util.List;

public class PersonIOTest {

	public static void main(String[] args) {
		testReadPeople();
		testWritePeople();
	}
	
	private static void testReadPeople() {
		File[] files = {new File( "src/exercise_person_accounts_ver1/people1.txt"),
				new File( "src/exercise_person_accounts_ver1/people2.txt"),
				new File( "src/exercise_person_accounts_ver1/people3.txt"),
				new File( "src/exercise_person_accounts_ver1/people4.txt")
		};
		for(File file : files) {
			testReadPeople(file);
		}
	}

	private static void testReadPeople(File file) {
		String msg = String.format("\ntestReadPeople, input file:%s\n", file.getName());
		System.out.println(msg);
		List<Person> people = PersonIO.readPeople(file);
		
		for(Person p : people) {
			System.out.println(p);
		}
	}

	private static void testWritePeople() {
		File[] inFiles = {new File( "src/exercise_person_accounts_ver1/people1.txt"),
				new File( "src/exercise_person_accounts_ver1/people2.txt"),
				new File( "src/exercise_person_accounts_ver1/people3.txt"),
				new File( "src/exercise_person_accounts_ver1/people4.txt")
		};
		File[] outFiles = {new File( "src/exercise_person_accounts_ver1/peopleOut1.txt"),
				new File( "src/exercise_person_accounts_ver1/peopleOut2.txt"),
				new File( "src/exercise_person_accounts_ver1/peopleOut3.txt"),
				new File( "src/exercise_person_accounts_ver1/peopleOut4.txt")
		};
		
		for(int i=0; i<inFiles.length; i++) {
			String msg = String.format("\ntestWritePeople(), out file:%s\n", inFiles[i].getName());
			System.out.println(msg);
			List<Person> people = PersonIO.readPeople(inFiles[i]);
			PersonIO.writePeople(outFiles[i], people);
			
			String lines;
			try {
				lines = Files.readString(outFiles[i].toPath());
				System.out.println(lines);
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		
	}

}
