package exercise_person_accounts_ver2;

import java.io.File;
import java.util.List;

public class PersonIOTest {
	static File[] files = {new File( "src/exercise_person_accounts_ver2/people1.txt"),
			new File( "src/exercise_person_accounts_ver2/people2.txt"),
			new File( "src/exercise_person_accounts_ver2/people3.txt"),
			new File( "src/exercise_person_accounts_ver2/people4.txt")
	};

	public static void main(String[] args) {
		testReadPeople(1);
		testReadPeople(2);
		testReadPeople(3);
		
	}

	private static void testReadPeople(int version) {
		for(File file : files) {
			testReadPeople(file, version);
		}
	}
	
	private static void testReadPeople(File file, int version) {
		String msg = String.format("\ntestReadPeople%d(), file:%s\n", version, file.getName());
		System.out.println(msg);
		List<Person> people = null;
		switch(version) {
			case 1: people = PersonIO.readPeople(file); break;
			case 2: people = PersonIO.readPeople2(file); break;
			case 3: people = PersonIO.readPeople3(file); break;
		}

		
		for(Person p : people) {
			System.out.println(p);
		}
	}
}
