package exercise_person_accounts_ver3;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Scanner;

/*
 * 2 solutions below
 */
public class PersonIO {

	public static void main(String[] args) {
		// See PersionIOTest.java for more tests
		File inFile = new File( "src/exercise_person_accounts_ver3/people1.txt" );
		List<Person> people = readPeople(inFile);
		
		for(Person p : people) {
			System.out.println(p);
		}

	}
	
	public static List<Person> readPeople(File file) {
		ArrayList<Person> people = new ArrayList<>();
		Person p = null;
		Account a = null;
	
		try {
			Scanner input = new Scanner(file);
			while(input.hasNext()) {
				String[] tokens = input.nextLine().split("\\s+");
				p = new Person(tokens[0]);
				int curToken = 1;
				while(curToken < tokens.length) {
					if(tokens[curToken].equals("b")) {
						curToken++;
						double bal = Double.parseDouble(tokens[curToken++]);
						a = new BasicAccount(bal);						
					}
					else if(tokens[curToken].equals("g")) {
						curToken++;
						double bal = Double.parseDouble(tokens[curToken++]);
						double intRate = Double.parseDouble(tokens[curToken++]);
						a = new GoldAccount(bal, intRate);
					}
					p.addAccount(a);
				}
				people.add(p);
			}
			input.close();
		}
		catch( IOException e ) {
			System.out.println(e);
		}
		return people;
	}

	public static List<Person> readPeople2(File file) {
		ArrayList<Person> people = new ArrayList<>();
		Person p = null;
		Account a = null;
	
		try {
			Scanner input = new Scanner(file);
			while(input.hasNext()) {
				String[] tokensArray = input.nextLine().split("\\s+");
				List<String> tokens = new ArrayList<>(Arrays.asList(tokensArray));
				p = new Person(tokens.remove(0));
				while(tokens.size()>0) {
					String type = tokens.remove(0);
					double bal = Double.parseDouble(tokens.remove(0));
					if(type.equals("b")) {
						a = new BasicAccount(bal);						
					}
					else if(type.equals("g")) {
						double intRate = Double.parseDouble(tokens.remove(0));
						a = new GoldAccount(bal, intRate);
					}
					p.addAccount(a);
				}
				people.add(p);
			}
			input.close();
		}
		catch( IOException e ) {
			System.out.println(e);
		}
		return people;
	}
}
