package exercise_person_accounts_ver4;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

/*
 * There are 3 versions. The last, readPeople3 is the best.
 */
public class PersonIO {

	public static void main(String[] args) {
		// See PersionIOTest.java for more tests
		File inFile = new File( "src/exercise_person_accounts_ver2/people1.txt" );
		List<Person> people = readPeople3(inFile);
		
		for(Person p : people) {
			System.out.println(p);
		}

	}
	
	public static List<Person> readPeople(File file) {
		ArrayList<Person> people = new ArrayList<>();
	
		try {
			Scanner input = new Scanner(file);
			String name = input.nextLine();  // assume first line is a Person
			Account a;
			while(input.hasNext()) {
				Person p = new Person(name);
				boolean hasMoreAccounts = true;
				while(hasMoreAccounts) {
					String line = input.nextLine();
					String[] tokens = line.split("\\s");
					if(tokens.length == 1) {  // new Person
						people.add(p);
						name = tokens[0];
						hasMoreAccounts = false;
						continue;
					}
					p.addAccount(buildAccount(tokens));
					if(!input.hasNext()) {
						hasMoreAccounts = false;
						people.add(p);
					}
				}
			}
			input.close();
		}
		catch( IOException e ) {
			System.out.println(e);
		}
		return people;
	}

	public static List<Person> readPeople2(File file) {
		ArrayList<Person> people = new ArrayList<>();
	
		try {
			Scanner input = new Scanner(file);
			// Read name
			String name = input.nextLine();  // assume first line is a Person
			Person p = new Person(name);
			Account a;
			while(input.hasNext()) {
				String[] tokens = input.nextLine().split("\\s+");
				if(tokens.length == 1) {
					people.add(p);
					p = new Person(tokens[0]);
					continue;
				}
				p.addAccount(buildAccount(tokens));
			}
			people.add(p);
			input.close();
		}
		catch( IOException e ) {
			System.out.println(e);
		}
		return people;
	}

	public static List<Person> readPeople3(File file) {
		ArrayList<Person> people = new ArrayList<>();
		ArrayList<String> lines = getLines(file);
		Person p = new Person(lines.remove(0));  // Assume first token is a name
		while(lines.size()!=0) {
			String[] tokens = lines.remove(0).split("\\s+");
			if(tokens.length == 1) {
				people.add(p);
				p = new Person(tokens[0]);
				continue;
			}
			p.addAccount(buildAccount(tokens));
		}
		people.add(p);
		return people;
	}

	private static Account buildAccount(String[] tokens) {
		Account a;
		if(tokens.length == 2) {  // BasicAccount
			double bal = Double.parseDouble(tokens[1]);
			a = new BasicAccount(bal);
		}
		else {  // GoldAccount
			double bal = Double.parseDouble(tokens[1]);
			double intRate = Double.parseDouble(tokens[2]);
			a = new GoldAccount(bal, intRate);
		}
		return a;
	}

	private static ArrayList<String> getLines(File file) {
		ArrayList<String> lines = new ArrayList<>();
		try {
			Scanner input = new Scanner(file);
			while(input.hasNext()) {
				lines.add(input.nextLine());
			}
			input.close();
		}
		catch( IOException e ) {
			System.out.println(e);
		}
		return lines;
	}
	public static void writePeople(File file, List<Person> people) {

	}

}
